"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPortAvailable = void 0;
const net_1 = require("net");
const isPortAvailable = async (port) => new Promise((resolve, reject) => {
    const server = (0, net_1.createServer)();
    server.once('error', (err) => {
        if (err.code === 'EADDRINUSE') {
            resolve(false);
        }
        else {
            reject(err);
        }
    });
    server.once('listening', () => {
        server.close(() => resolve(true));
    });
    server.listen(port);
});
exports.isPortAvailable = isPortAvailable;
//# sourceMappingURL=network.js.map